<?php
/**
 * Created by PhpStorm.
 * User: YannickBreillet
 * Date: 11/07/2016
 * Time: 10:16
 */

namespace Bydedi\Tracking\Google;

/**
 * Class TagManager
 * @package Bydedi\Tracking\Google
 */
class TagManager
{
    /**
     * @var bool
     */
    protected static $isInit = false;

    /**
     * @var array|null $config
     */
    protected static $config = null;

    /**
     * @param array $config
     */
    public static function init($config = array())
    {
        self::$config = $config;
    }

    /**
     * Check if it's initialized.
     * If not trigger a warning error
     */
    protected static function triggerErrorIfNotInit()
    {
        if (is_null(self::$config)) {
            trigger_error("Google TagManager n'est pas initialisé", E_USER_WARNING);
        }
    }

    public static function getVisites($param = array())
    {
        self::common($param);
    }

    public static function common($param)
    {
        if (self::$isInit == true) {
            return "";
        }

        self::$isInit = true;

        $tracker = "
        <noscript>
            <iframe src=\"//www.googletagmanager.com/ns.html?id=" . self::$config['id'] . "\" height=\"0\" width=\"0\" style=\"display:none;visibility:hidden\"></iframe>
        </noscript>
        <script>(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
            new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
            j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
            '//www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
            })(window,document,'script','dataLayer','" . self::$config['id'] . "');
        </script>";

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $tracker);
        }
    }
    
}